#include <stdio.h>
#include <string.h>
#include <ggi/ggi.h>

#include "loadppm.h"

char *fgetsnoc(char *buffer,size_t size,FILE *inf){
	char *rc;
	while(1) {
		rc=fgets(buffer,size,inf);
		if (rc&&*rc!='#') return rc;
	}
}

#if 0
int loadppm(ggi_visual_t vis,int x,int y,char *name,int *w,int *h) {
	struct rgb{ unsigned char r,g,b; } rgb;
	ggi_color col;
	FILE *inf;
	int xx,yy;
	char buffer[256];
	
	if (NULL==(inf=fopen(name,"r"))) return 1;
	fgetsnoc(buffer,sizeof(buffer),inf);
	if (strcmp(buffer,"P6\n")) return 1;
	fgetsnoc(buffer,sizeof(buffer),inf);
	*w=*h=0;
	sscanf(buffer,"%d %d",w,h);
	fgetsnoc(buffer,sizeof(buffer),inf);
	for(yy=0;yy<*h;yy++)
		for(xx=0;xx<*w;xx++) {
			fread(&rgb,sizeof(rgb),1,inf);
			col.r=rgb.r*257;
			col.g=rgb.g*257;
			col.b=rgb.b*257;
			ggiPutPixel(vis,x+xx,y+yy,ggiMapColor(vis,&col));
		}
	fclose(inf);
	return 0;
}
#endif

sprite16 *loadsprite16(const char *name){
	struct rgb{ unsigned char r,g,b; } rgb;
	FILE *inf;
	int xx,yy,pos;
	char buffer[256];
	sprite16 *rc;
	
	if (NULL==(rc=malloc(sizeof(sprite16)))) return NULL;

	if (NULL==(inf=fopen(name,"r"))) {
		free(rc);
		return NULL;
	}
	fgetsnoc(buffer,sizeof(buffer),inf);
	if (strcmp(buffer,"P6\n")) {
		fclose(inf);
		free(rc);
		return NULL;
	}
	fgetsnoc(buffer,sizeof(buffer),inf);
	rc->w=rc->h=0;
	sscanf(buffer,"%d %d",&rc->w,&rc->h);
	if (rc->w<=0||rc->h<=0||
		NULL==(rc->data=malloc(sizeof(rc->data[0])*rc->w*rc->h))) {
		fclose(inf);
		free(rc);
		return NULL;
	}
	fgetsnoc(buffer,sizeof(buffer),inf);
	
#if 0
	fprintf(stderr,"Loading %s size %d,%d at %p %p.\n",
		name, rc->w, rc->h, rc, rc->data);
#endif
	pos=0;
	for(yy=0;yy<rc->h;yy++)
		for(xx=0;xx<rc->w;xx++) {
			fread(&rgb,sizeof(rgb),1,inf);
			rc->data[pos++]=(rgb.r&0xf8)<<8 |
					(rgb.g&0xfc)<<3 |
					(rgb.b&0xf8)>>3;
		}
	fclose(inf);
	return rc;
}

void freesprite16(sprite16 *sprite) {
	if (sprite) free(sprite->data);
	free(sprite);
}
